unit ThreadDemoThreadUnit;

interface

uses
  Classes, SysUtils, Windows, Messages,ThreadControllerUnit;

type
  ThreadDemoThread = class(TThread)
  private
    { Private declarations }
    FThreadController: TThreadController;
  protected
    procedure Execute; override;
    procedure CheckMessage;
  public
    constructor create(CreateSuspended: Boolean; ThreadController: TThreadController);
    destructor Destroy; override;
  end;

implementation

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure ThreadDemoThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ ThreadDemoThread }

procedure ThreadDemoThread.CheckMessage;
var
  Msg: TMsg;
begin
  while (not Terminated) and (Windows.PeekMessage(Msg,0,0,0,PM_REMOVE)) do begin
    case Msg.Message of
      WM_QUIT: Terminate;
    end;
  end;
end;

constructor ThreadDemoThread.create(CreateSuspended: Boolean; ThreadController: TThreadController);
begin
  //Always Create the inherited thread suspended to stop
  //it running before we have finished the constructor
  Inherited Create(True);

  //Do our initialization here
  FThreadController := ThreadController;
  FThreadController.AddThread(self);
  FreeOnTErminate := True;

  //If thread susposed to execute now resume it
  if not Createsuspended then
    Resume;
end;

destructor ThreadDemoThread.Destroy;
begin
  FThreadController.RemoveThread(Self);
  inherited;
end;

procedure ThreadDemoThread.Execute;
var
  MSg: TMsg;
begin
  { Place thread code here }
  Windows.WaitMessage;
  if Windows.PeekMessage(Msg,0,WM_QUIT,WM_QUIT,PM_Remove) then
    exit;
  //Process Other Messages Here.
  CheckMessage;
end;

end.
 